#!/usr/bin/perl

#use strict;
#no strict 'subs';
use Data::Dumper;
use Tie::ShareLite qw( :lock );
my $log = '/var/log/lmgrd-poller.log';
my %licstatus;
  $ipc = tie %licstatus, 'Tie::ShareLite', -key     => 2030405,
					-mode    => 0666,
                                        -create  => 'yes',
                                        -destroy => 'no'
    or die("Could not tie to shared memory: $!");

my $lmutil = '/usr/local/sbin/lmutil';

# Servers to poll, daemon name, and TCP port
my %licservers = (
        'lic1.domain.com'    => { 
		'1700'		=> {
			'alterad' => 'Altera',
			'synplctyd' => 'Synplicity',
			'actlmgrd' => 'Actel',
			'mgcld' => 'MentorGraphics',
			'denalid' => 'Denali',
			'snpslmd' => 'Synopsys',
			'wrsd' => 'WindRiver',
			'cdslmd' => 'Cadence',
			'borland' => 'Borland',
		},
		'1701'		=> {
			'Tartan' => 'Tartan',
		},
		'1703'		=> {
			'thermal' => 'TasPCB',
		},
	},
        'lic2.domain.com'    => {
		'1702'		=> {
	                'actlmgrd' => 'Actel',
		},
        },
        'lic3.domain.com'        =>  { 
		'1700'		=> {
                	'MSC' => 'MSC',
		},
        }, 
);

sub do_poll() {
$0 = "lmgrd-poller.pl: Polling...";
my $server;
$ipc->lock( LOCK_SH );
foreach my $lserver ( keys %licservers ) {
	foreach my $lport ( keys %{$licservers{$lserver}} ) {
		foreach my $app ( keys %{$licservers{$lserver}{$lport}} ) {
			my $server = "$lport\@$lserver";
			print "$server/$app\n";
			open(LICENSES, "$lmutil lmstat -c $server -S $app|") or die("Couldn't run $lmutil.");

				foreach my $line (<LICENSES>) {
	 			if ($line =~ /^Users\sof\s(.+):\s+\(Total\sof\s(\d+)\s\w+\sissued;\s+Total\sof\s(\d+)\s\w+\sin\suse\)/) {
	
					# Well, this is stupid.
					my %tmpstat = %licstatus;
					$tmpstat{$lserver}{$1}{total} = $2;
					$tmpstat{$lserver}{$1}{package} = $licservers{$lserver}{$lport}{$app};
					$tmpstat{$lserver}{$1}{inuse} = $3;
					$tmpstat{$lserver}{$1}{port} = $lport;
					%licstatus = %tmpstat;
#					print Dumper %licstatus;
	 			}
			}
			close(LICENSES);
		}
	}
}
$ipc->unlock();
}
sub daemonize {
    open STDOUT, ">>$log" or die "Can't write to $log: $!";
    defined(my $pid = fork)   or die "Can't fork: $!";
    exit if $pid;
    setsid                    or die "Can't start a new session: $!";
    umask 0;
}

&daemonize;

while (true) {
	&do_poll();
	$0 = "lmgrd-poller.pl: Sleeping...";
	sleep 240;
}

print Dumper %licstatus;
