#!/usr/bin/perl

use strict;
use Data::Dumper;
use Tie::ShareLite qw( :lock );

my $package;
my %licstatus;
 my $ipc = tie %licstatus, 'Tie::ShareLite', -key     => 2030405
    or die("Could not tie to shared memory: $!");

my $server = $ARGV[0];
my $port = $ARGV[1];
my $func = $ARGV[2];

 $ipc->lock( LOCK_SH );
	if ($func eq "index") {
		foreach my $appname ( sort keys %{$licstatus{$server}} ) {
			print "$appname\n" if ($licstatus{$server}{$appname}{port} == $port);
		}
	} elsif ($func eq "get") {
		# print "$licstatus{$server}{$ARGV[4]}{inuse}" . ":" . "$licstatus{$server}{$ARGV[4]}{total}";
		if($ARGV[3] eq "inuse") {
			print "$licstatus{$server}{$ARGV[4]}{inuse}";
		} else {
			print "$licstatus{$server}{$ARGV[4]}{total}";
		}
	} elsif ($server eq "test") {
		print "Dumping hash...\n";
		print Dumper %licstatus;
		exit;
	} elsif ($func eq "query") {
		foreach my $appname ( sort keys %{$licstatus{$server}} ) {
			if ($licstatus{$server}{$appname}{port} == $port) {
			my $data;
			if ($ARGV[3] eq 'appname') {
				$data = $appname;
			} else {
				$data = $licstatus{$server}{$appname}{$ARGV[3]};
			}
			#print "$ARGV[3] -- DATA -- $data\n";
			print "$appname:$data\n";
			}
		}
	}
$ipc->unlock();
